//------------------------------------------------------------------
#property copyright "www.forex-tsd.cm"
#property link      "www.forex-tsd.cm"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1  LimeGreen
#property indicator_color2  DarkGray
#property indicator_color3  Orange
#property indicator_color4  Orange
#property indicator_color5  PaleVioletRed
#property indicator_style1  STYLE_DOT
#property indicator_style5  STYLE_DOT

//
//
//
//
//

extern string TimeFrame      = "Current time frame";
extern int    HighLowPeriod  = 10;

//
//
//
//
//

double bandUp[];
double bandMi[];
double bandMida[];
double bandMidb[];
double bandDn[];
double trend[];
string indicatorFileName;
bool   returnBars;
int    timeFrame;


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,bandUp);
   SetIndexBuffer(1,bandMi);
   SetIndexBuffer(2,bandMida);
   SetIndexBuffer(3,bandMidb);
   SetIndexBuffer(4,bandDn);
   SetIndexBuffer(5,trend);
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame == "returnBars"; if (returnBars) return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);
   return(0);
}
int deinit()
{
   return(0); 
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { bandUp[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (timeFrame!=Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   if (trend[limit]==-1) CleanPoint(limit,bandMida,bandMidb);
   for(int i = limit; i >= 0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);               
      bandUp[i] = iHigh(NULL,timeFrame,iHighest(NULL,timeFrame,MODE_HIGH,HighLowPeriod,y));
      bandDn[i] = iLow (NULL,timeFrame,iLowest (NULL,timeFrame,MODE_LOW ,HighLowPeriod,y));
      bandMi[i] = (bandUp[i]+bandDn[i])/2.0;
      trend[i]  = trend[i+1];
         if (bandMi[i]>bandMi[i+1]) trend[i] =  1;
         if (bandMi[i]<bandMi[i+1]) trend[i] = -1;
         bandMida[i] = EMPTY_VALUE;
         bandMidb[i] = EMPTY_VALUE;
            if (trend[i] == -1) PlotPoint(i,bandMida,bandMidb,bandMi);
   }
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}